Public Sub Main()
Dim s, n, b

	If msgBox("Esta actualizacion elimina toda la informacin" & vbCrLf & _
						"sobre retenciones del ISLR registradas." & vbCrLf & _
						"Est seguro de que desea continuar?", vbYesNo, "Confirmacion") = vbNo Then
		Exit Sub
	End If

	Do
		s = InputBox("Numero del proximo comprobante de retencion a emitir", "Retenciones del ISLR")
		If s = "" Then Exit Sub
		b = ValidarNumero(CStr(s))
		If Not b Then
			MsgBox "Introduzca un numero valido, por favor", vbCritical, "Dato invalido"
		Else
			On Error Resume Next
			n = CLng(s)
			If Err.Number Then
				n = 0
				Err.Clear
			End If
			If n <= 0 Then
				MsgBox "Introduzca un numero positivo sin separadores de millar ni signo decimal"
				b = False
			End If
		End If
	Loop While b = False

	On Error Goto 0
	Set cn = CrearObjeto("Database")

	On Error Resume Next
	cn.Execute "DROP Table RetencionesISLR"
	On Error GoTo 0

	cn.Execute "CREATE TABLE rislrConceptos (Id long PRIMARY KEY NOT NULL, " & _
						 "   Codigo TEXT (50), Descripcion TEXT (70), Referencia TEXT (50), orden int)" 
	cn.Execute "CREATE UNIQUE INDEX IX_rislrConceptos ON rislrConceptos (Codigo)"
	cn.Execute "CREATE TABLE rislrMetodos (Id AUTOINCREMENT PRIMARY KEY NOT NULL, IdConcepto LONG, TipoPersona BYTE, TipoMetodo BYTE, PorcentajeBase Double, " & _
						 "MontoMinimo currency, Deducible currency, Limite Currency, Porcentaje Double)"
	cn.Execute "CREATE UNIQUE INDEX IX_rislrMetodos ON rislrMetodos(IdConcepto, TipoPersona)"
	cn.Execute "CREATE TABLE rislrParametrosT2 (id AUTOINCREMENT PRIMARY KEY, idMetodo LONG, Hasta Currency, Unidad BYTE, Porcentaje Double)"
	cn.Execute "CREATE INDEX IX_rislrParametrosT2 ON rislrParametrosT2(idMetodo, Hasta)"
	cn.Execute "CREATE TABLE rislrParametrosT3 (id AUTOINCREMENT, idMetodo LONG, Archivo TEXT(128))"

	cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (1, 'HONORARIOS', 'Honorarios profesionales', '1,a', 1)"
	cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (2, 'COMISIONES', 'Comisiones pagadas', '2', 3)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (3, 'INTERES1', 'Intereses en creditos invertidos', '3,a', 5)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (4, 'INTERES2', 'Intereses en prestamos de capital', '3,c', 9)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (5, 'NOTICIAS', 'Pagos a agencias de noticias internacionales', '4', 10)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (6, 'FLETESINT', 'Fletes internacionales', '5', 11)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (7, 'FLETESNAC', 'Fletes nacionales', '5', 4)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (8, 'PELICULAS', 'Exhibicion de peliculas', '6', 12)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (9, 'REGALIAS', 'Regalias y similares', '7,1', 13)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (10, 'ASISTEC', 'Asistencia tecnica', '7,2', 14)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (11, 'SERVTEC', 'Servicios tecnologicos', '7,3', 15)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (12, 'SEGUROS', 'Primas de seguros', '8',	16)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (13, 'JUEGOS', 'Ganancias en juegos o apuestas', '9',	17)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (14, 'LOTERIAS', 'Ganancias en loterias o hipodromos', '9', 18)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (15, 'SERVICIOS', 'Ejecucion de obras y servicios', '11', 2)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (16, 'ALQUILERES', 'Arrendamiento de inmuebles', '12', 8)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (17, 'LEASING', 'Arrendamiento de bienes muebles', '13', 7)"
  cn.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (18, 'PUBLICIDAD', 'Publicidad, propaganda y venta de espacios', '19', 6)"

  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (3, 1, 1, 95.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (3, 3, 2, 95.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (5, 3, 2, 15.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (6, 3, 2, 5.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 3, 2, 10.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (8, 1, 1, 25.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (8, 3, 2, 25.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (9, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (9, 3, 2, 90.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (10, 1, 1, 30.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (10, 3, 2, 30.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (11, 1, 1, 50.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (11, 3, 2, 50.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (12, 3, 1, 30.00, 0.00, 0.00, 0.00, 10.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 0, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 2, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 3, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 0, 1, 100.00, 0.00, 0.00, 0.00, 16.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 1, 1, 100.00, 0.00, 0.00, 0.00, 16.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 2, 1, 100.00, 0.00, 0.00, 0.00, 16.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 3, 1, 100.00, 0.00, 0.00, 0.00, 16.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 0, 1, 100.00, 3833.34, 38.33, 0.00, 1.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 2, 1, 100.00, 0.00, 0.00, 0.00, 2.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 0, 1, 100.00, 3833.34, 0.00, 0.00, 1.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 2, 1, 100.00, 25.00, 0.00, 0.00, 3.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)"
  cn.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)"

  cn.Execute "INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 2000.00, 1, 22.00)"
  cn.Execute "INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 3000.00, 1, 34.00)"
  cn.Execute "INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 0.00, 1, 15.00)"
	
	cn.Execute "CREATE TABLE RetencionesISLR (Numero AUTOINCREMENT PRIMARY KEY NOT NULL , tipoEntidadRelacionada text (3) NOT NULL , codigoEntidad text(20) NOT NULL , " & _
		"fecha datetime , refDocumento TEXT (20) NOT NULL , totalPagado money NOT NULL , baseImponible money NOT NULL , porcentajeRetencion double NOT NULL , " & _
		"montoRetenido money NOT NULL, numRef long, TipoDoc TEXT (3), NumDoc LONG , RIFSujeto TEXT(15), NombreSujeto TEXT(50), DireccionSujeto TEXT(160), ConceptoRetencion LONG, " & _
		"TipoPersona BYTE)"

	cn.Execute "CREATE INDEX retDocOrigen ON RetencionesISLR (TipoDoc, NumDoc)"
	cn.Execute "CREATE INDEX IX_RetencionesISLR7 ON RetencionesISLR(tipoEntidadRelacionada, codigoEntidad, fecha)"
	cn.Execute "CREATE UNIQUE INDEX PrimaryKey ON RetencionesISLR (Numero)"

	cn.Execute "ALTER Table Contadores ADD RetencionISLR LONG"
	cn.Execute "UPDATE Contadores SET RetencionISLR = " & NumeroDB(n)
	MsgBox "Su base de datos ya es compatible con la version 6.4.30", vbOk, "Actualizacion"
End Sub
