CREATE TABLE ConsignacionesCompra (
	Numero bigint IDENTITY (1, 1) PRIMARY KEY NOT NULL,
	FechaRegistro datetime NOT NULL DEFAULT getdate(),
	FechaTransaccion datetime NOT NULL,
	Operador nvarchar (8),
	CodigoProveedor nvarchar (20),
	RefProveedor nvarchar (20),
	CostoMercancia money NOT NULL,
	Descuento1 float NOT NULL DEFAULT 0,
	Descuento2 float NOT NULL DEFAULT 0,
	Impuesto1 money NOT NULL DEFAULT 0,
	Impuesto2 money NOT NULL DEFAULT 0,
	Almacen nvarchar (8),
	Liquidada smallint NOT NULL DEFAULT 0,
	Procesada smallint NOT NULL DEFAULT 0,
	Notas nvarchar (255),
);


CREATE  INDEX IX_Liquidada ON ConsignacionesCompra(Liquidada, CodigoProveedor);
CREATE  INDEX IX_ProvFecha ON ConsignacionesCompra(CodigoProveedor, FechaTransaccion);
CREATE  INDEX IX_ProvRef ON ConsignacionesCompra(CodigoProveedor, RefProveedor);

CREATE TABLE ConsignacionesDetalles (
	NumeroConsignacion bigint NOT NULL,
	Renglon smallint NOT NULL,
	CodigoItem nvarchar (20),
	Presentacion nvarchar (12),
	FactorEmpaque float NOT NULL,
	CantidadRecibida float NOT NULL,
	PrecioEfectivo money NOT NULL,
	Pendientes float NOT NULL 
);

ALTER TABLE ConsignacionesDetalles  WITH NOCHECK ADD CONSTRAINT  PK_ConsignacionesDetalles  PRIMARY KEY  CLUSTERED (NumeroConsignacion, Renglon);
CREATE  INDEX IX_ItemConsignacion ON ConsignacionesDetalles(NumeroConsignacion,CodigoItem);
CREATE  INDEX IX_ItemsConsignados ON ConsignacionesDetalles(Pendientes,CodigoItem);
CREATE  INDEX IX_Item ON ConsignacionesDetalles(CodigoItem,NumeroConsignacion);

ALTER TABLE ParametrosEmpresa ADD CuentaDeudoraConsignaciones NVARCHAR(20) DEFAULT '';
ALTER TABLE ParametrosEmpresa ADD CuentaAcreedoraConsignaciones NVARCHAR(20) DEFAULT '';

ALTER TABLE ConsignacionesDetalles ADD CONSTRAINT FK_ConsignacionesDetalles_ConsignacionesCompra
	FOREIGN KEY (NumeroConsignacion) REFERENCES ConsignacionesCompra (Numero) ON DELETE CASCADE  ON UPDATE CASCADE ;

ALTER TABLE itemsInventario ADD Consignadas FLOAT NOT NULL DEFAULT 0;
ALTER TABLE DevolucionesCompra ADD TipoDocumento NVARCHAR(3) NOT NULL DEFAULT 'RCM';

GO

UPDATE DevolucionesCompra SET TipoDocumento = 'RCM';
