CREATE TABLE RelacionesIVARetenido (
	NumeroRetencion bigint PRIMARY KEY NOT NULL ,
	Fecha datetime NOT NULL ,
	Operador nvarchar (20) NOT NULL ,
	AnhoFiscal int NOT NULL ,
	Mes int NOT NULL ,
	RifProveedor nvarchar (13) NOT NULL ,
	NombreProveedor nvarchar (50) NOT NULL 
)

CREATE TABLE DocumentosFiscales (
  Id bigint NOT NULL IDENTITY (1, 1) PRIMARY KEY,
  Fecha datetime NOT NULL default getdate(),
  TipoDoc nvarchar(3) NOT NULL default '',
  NumeroDoc bigint NOT NULL default 0,
  TipoEntidad nvarchar(3) NOT NULL default 0,
  CodigoEntidad nvarchar(20) NOT NULL default 0,
  Referencia nvarchar(20) NOT NULL default '',
  NumeroControlInicial bigint NOT NULL default 0,
  NumeroControlFinal bigint NOT NULL default 0,
  FacturaRelacionada nvarchar(20) NOT NULL default '',
  Exento money NOT NULL default 0,
  Gravable1 money NOT NULL default 0,
  Tasa1 float NOT NULL default 0,
  Gravable2 money NOT NULL default 0,
  Tasa2 float NOT NULL default 0,
  Impuesto1 money NOT NULL default 0,
  Impuesto2 money NOT NULL default 0,
  Retencion money NOT NULL default 0,
  TipoDocFiscal nvarchar(3) NOT NULL,
  RifEntidad nvarchar(14) NOT NULL default '',
  NombreEntidad nvarchar(50) NOT NULL default '',
  Relacionado bigint NOT NULL default 0
);

CREATE INDEX Documentos_Fiscales_DocumentosEntidad  ON DocumentosFiscales (TipoEntidad, CodigoEntidad, Fecha, Id);
CREATE INDEX DocumentosFiscales_Documentos ON DocumentosFiscales (TipoDoc, NumeroDoc);
CREATE INDEX DocumentosDocumento ON DocumentosFiscales (TipoEntidad, CodigoEntidad, TipoDoc, Referencia);
