ALTER TABLE Contadores ADD RetencionISLR INT NOT NULL DEFAULT 1

CREATE TABLE rislrConceptos (
	Id int PRIMARY KEY NOT NULL,
	Codigo nvarchar (50),
	Descripcion nvarchar (70),
	Referencia nvarchar (50),
	orden smallint NULL 
) 

ALTER TABLE rislrConceptos ADD CONSTRAINT IX_rislrConceptos UNIQUE  NONCLUSTERED (Codigo)   

CREATE TABLE rislrMetodos (
	Id int IDENTITY (1, 1) PRIMARY KEY NOT NULL,
	IdConcepto int NULL,
	TipoPersona tinyint NULL,
	TipoMetodo tinyint NULL,
	PorcentajeBase float NULL,
	MontoMinimo money NULL,
	Deducible money NULL,
	Limite money NULL,
	Porcentaje float NULL 
) 

CREATE UNIQUE INDEX IX_rislrMetodos ON rislrMetodos(IdConcepto, TipoPersona)   

CREATE TABLE rislrParametrosT2 (
	id int IDENTITY (1,1) PRIMARY KEY NOT NULL,
	idMetodo int NULL,
	Hasta money NULL,
	Unidad bit NOT NULL,
	Porcentaje float NULL 
) 
CREATE INDEX IX_rislrParametrosT2 ON rislrParametrosT2(idMetodo, Hasta) 

CREATE TABLE rislrParametrosT3 (
	id int IDENTITY (1,1) NOT NULL,
	idMetodo int NULL,
	Archivo nvarchar (128)
) 

  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (1, 'HONORARIOS', 'Honorarios profesionales', '1,a', 1)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (2, 'COMISIONES', 'Comisiones pagadas', '2', 3)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (3, 'INTERES1', 'Intereses en creditos invertidos', '3,a', 5)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (4, 'INTERES2', 'Intereses en prestamos de capital', '3,c', 9)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (5, 'NOTICIAS', 'Pagos a agencias de noticias internacionales', '4', 10)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (6, 'FLETESINT', 'Fletes internacionales', '5', 11)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (7, 'FLETESNAC', 'Fletes nacionales', '5', 4)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (8, 'PELICULAS', 'Exhibicion de peliculas', '6', 12)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (9, 'REGALIAS', 'Regalias y similares', '7,1', 13)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (10, 'ASISTEC', 'Asistencia tecnica', '7,2', 14)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (11, 'SERVTEC', 'Servicios tecnologicos', '7,3', 15)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (12, 'SEGUROS', 'Primas de seguros', '8',	16)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (13, 'JUEGOS', 'Ganancias en juegos o apuestas', '9',	17)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (14, 'LOTERIAS', 'Ganancias en loterias o hipodromos', '9', 18)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (15, 'SERVICIOS', 'Ejecucion de obras y servicios', '11', 2)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (16, 'ALQUILERES', 'Arrendamiento de inmuebles', '12', 8)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (17, 'LEASING', 'Arrendamiento de bienes muebles', '13', 7)
  INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (18, 'PUBLICIDAD', 'Publicidad, propaganda y venta de espacios', '19', 6)

  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (3, 1, 1, 95.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (3, 3, 2, 95.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (5, 3, 2, 15.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (6, 3, 2, 5.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 3, 2, 10.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (8, 1, 1, 25.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (8, 3, 2, 25.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (9, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (9, 3, 2, 90.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (10, 1, 1, 30.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (10, 3, 2, 30.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (11, 1, 1, 50.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (11, 3, 2, 50.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (12, 3, 1, 30.00, 0.00, 0.00, 0.00, 10.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 0, 1, 100.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 2, 1, 100.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 3, 1, 100.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 0, 1, 100.00, 0.00, 0.00, 0.00, 16.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 1, 1, 100.00, 0.00, 0.00, 0.00, 16.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 2, 1, 100.00, 0.00, 0.00, 0.00, 16.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 3, 1, 100.00, 0.00, 0.00, 0.00, 16.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 0, 1, 100.00, 3833.34, 38.33, 0.00, 1.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 2, 1, 100.00, 0.00, 0.00, 0.00, 2.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 0, 1, 100.00, 3833.34, 0.00, 0.00, 1.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 2, 1, 100.00, 25.00, 0.00, 0.00, 3.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 0, 1, 100.00, 3833.34, 115.00, 0.00, 3.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 2, 1, 100.00, 25.00, 0.00, 0.00, 5.00)
  INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)

  INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 2000.00, 1, 22.00)
  INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 3000.00, 1, 34.00)
  INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 0.00, 1, 15.00)
