DROP Table IVARetenido;

CREATE TABLE [IVARetenido] (
	[Id] [int] IDENTITY (1, 1) NOT NULL ,
	[CodigoProveedor] [nvarchar] (20) NULL ,
	[RifProveedor] [nvarchar] (14) NULL ,
	[NombreProveedor] [nvarchar] (50) NOT NULL ,
	[NumeroFactura] [nvarchar] (12) NULL ,
	[FechaCobro] [datetime] NOT NULL ,
	[MontoExento] [money] NOT NULL CONSTRAINT [DF_IVARetenido_MontoBruto] DEFAULT (0),
	[MontoGravable1] [money] NOT NULL CONSTRAINT [DF_IVARetenido_MontoIVA] DEFAULT (0),
	[MontoGravable2] [money] NOT NULL CONSTRAINT [DF_IVARetenido_MontoRetencion] DEFAULT (0),
	[TipoDoc] [nvarchar] (3) NULL ,
	[NumeroDoc] [int] NULL ,
	[NumeroControl] [int] NULL ,
	[Cancelado] [int] NULL ,
	[Relacionado] [bigint] NULL ,
	[Impuesto1] [float] NULL ,
	[Impuesto2] [float] NULL ,
	[IvaTotal] [money] NULL ,
	[IvaRetenido] [money] NULL 
) ON [PRIMARY];

CREATE INDEX IvaRetenidoDOC
ON IVARetenido (TipoDoc, NumeroDoc);

ALTER TABLE ParametrosEmpresa ADD
	Contribuyente smallint NOT NULL Default 0,
	PorcentajeRetencionIVACE FLOAT NOT NULL DEFAULT 75,
	ValorActualUT DECIMAL NOT NULL DEFAULT 29400;

ALTER TABLE Compras
	ADD NumeroControl Integer
	DEFAULT 0 NOT NULL;

ALTER TABLE DevolucionesCompra
  ADD RefProveedor NVARCHAR(20) NOT NULL
  DEFAULT  '',
  NumeroControl int NOT NULL
  DEFAULT 0;

-- Inicio de la actualizacion de revision de movimientos caja
ALTER TABLE MovimientosCaja
  ADD Hora smalldatetime NULL;

EXEC sp_rename 'DetallesIngresoCaja.Referencia', 'NumeroDocumento', 'COLUMN';
EXEC sp_rename 'DetallesIngresoCaja.Clave', 'ClaveAutorizacion', 'COLUMN';

ALTER TABLE DetallesIngresoCaja
  ADD Id INT IDENTITY (1, 1) NOT NULL,
      MontoNominal money NOT NULL default 0,
      NumeroCuenta nvarchar(20) NOT NULL DEFAULT '',
      idTitular nvarchar(20) NOT NULL DEFAULT '';

ALTER TABLE DetallesIngresoCaja
 ALTER COLUMN Medio nVarchar(8);

ALTER TABLE DetallesIngresoCaja
 ALTER COLUMN Emisor nVarchar(20);

CREATE UNIQUE INDEX idxDetallesIngresoCajaID 
ON DetallesIngresoCaja (Id);

CREATE UNIQUE INDEX idxDetallesIngresoCajaTransID
ON DetallesIngresoCaja (TransID, Id);

CREATE INDEX idxDetallesIngresoCajaMedioEmisor
ON DetallesIngresoCaja (Medio, Emisor);

CREATE Table DetallesDenominacion (
  Id INT IDENTITY (1, 1) PRIMARY KEY NOT NULL,
  IdDetalle INT NOT NULL,
  Denominacion Money,
  CantidadRecibida SmallInt);

CREATE UNIQUE INDEX idxDetallesDenominacionID 
ON DetallesDenominacion (Id);

CREATE INDEX idxDetallesDenominacionDetalle
ON DetallesDenominacion (IdDetalle, Id);

CREATE TABLE MediosPago (
  Codigo nVarChar (8) PRIMARY KEY NOT NULL,
  Descripcion nVarChar(24) NOT NULL,
  Atributos INT NOT NULL DEFAULT 0,
  PorcentajeRetencionEmisor float NOT NULL default 0,
  PorcentajeISLR float NOT NULL default 0,
  CuentaActivo nVarchar(20) NOT NULL DEFAULT '',
  CuentaComisiones NVARCHAR(20) NOT NULL DEFAULT '',
  BancoRelacionado NVARCHAR(20) NOT NULL DEFAULT '',
  Clase SMALLINT NOT NULL DEFAULT 0
);

If not exists 
  (select * FROM dbo.sysobjects where name = 'ndxNumero' 
    AND parent_obj = (select id from sysobjects where name = 'FacturasPOS'))
  CREATE UNIQUE CLUSTERED INDEX ndxNumero ON dbo.FacturasPOS (Numero);

--UPDATE DetallesIngresoCaja SET MontoNominal = Monto;
