ALTER TABLE ParametrosEmpresa
  ADD Contribuyente INTEGER DEFAULT 0,
  ADD PorcentajeRetencionIVACE DECIMAL(6,2) DEFAULT 75,
  ADD ValorActualUT DECIMAL(18, 2) DEFAULT 29400;

DROP TABLE IvaRetenido;

CREATE TABLE IVARetenido (
	Id int auto_increment NOT NULL, 
	CodigoProveedor varchar (20) NULL,
	RifProveedor varchar (14) NULL ,
	NombreProveedor varchar (50) NOT NULL ,
	NumeroFactura varchar (12) NULL ,
	FechaCobro DECIMAL(18, 2) NOT NULL ,
	MontoExento DECIMAL(18, 2) NOT NULL DEFAULT 0,
	MontoGravable1 DECIMAL(18, 2) NOT NULL DEFAULT 0,
	MontoGravable2 DECIMAL(18, 2)  NOT NULL DEFAULT 0,
	TipoDoc varchar (3) NULL ,
	NumeroDoc int NULL ,
	NumeroControl int NULL ,
	Cancelado int NULL ,
	Relacionado int NULL ,
	Impuesto1 float NULL ,
	Impuesto2 float NULL ,
	IvaTotal DECIMAL(18, 2) NULL ,
	IvaRetenido DECIMAL(18, 2) NULL
);
 
CREATE INDEX IvaRetenidoDOC
  ON IVARetenido (TipoDoc, NumeroDoc);

ALTER TABLE Compras
 ADD NumeroControl Integer(8)
 DEFAULT 0 NOT NULL;

 ALTER TABLE librocompras 
  ADD NumeroControl INTEGER(8)
  NOT NULL default '0';

 ALTER TABLE devolucionescompra
  ADD RefProveedor VARCHAR(20)
  NOT NULL DEFAULT '',
  NumeroControl Integer(8)
  NOT NULL DEFAULT '0';

  -- Inicio de la actualizacion de revision de movimientos caja
ALTER TABLE MovimientosCaja
  ADD Hora datetime NULL;

ALTER TABLE DetallesIngresoCaja
  CHANGE Referencia NumeroDocumento VarChar(20),
  CHANGE Clave ClaveAutorizacion VarChar(20);

ALTER TABLE DetallesIngresoCaja
  ADD Id INT auto_increment PRIMARY KEY NOT NULL,
  ADD MontoNominal DECIMAL (18, 2) NOT NULL default 0,
  ADD NumeroCuenta varchar(20) NOT NULL DEFAULT '',
  ADD idTitular varchar(20) NOT NULL DEFAULT '';

ALTER TABLE DetallesIngresoCaja
  MODIFY COLUMN Medio VARCHAR(8),
  MODIFY COLUMN Emisor VARCHAR (20);

UPDATE DetallesIngresoCaja SET MontoNominal = Monto;

CREATE UNIQUE INDEX idxDetallesIngresoCajaTransID
ON DetallesIngresoCaja (TransID, Id);

CREATE Table DetallesDenominacion (
  Id INT auto_increment PRIMARY KEY NOT NULL,
  IdDetalle INT NOT NULL,
  Denominacion DECIMAL (18, 2),
  CantidadRecibida Integer(4));

CREATE UNIQUE INDEX idxDetallesDenominacionDetalle
ON DetallesDenominacion (IdDetalle, Id);

CREATE TABLE MediosPago (
  Codigo VarChar (8) PRIMARY KEY NOT NULL,
  Descripcion VarChar(24) NOT NULL,
  Atributos INT NOT NULL DEFAULT 0,
  PorcentajeRetencionEmisor float NOT NULL default 0,
  PorcentajeISLR float NOT NULL default 0,
  CuentaActivo Varchar(20) NOT NULL DEFAULT '',
  CuentaComisiones VARCHAR(20) NOT NULL DEFAULT '',
  BancoRelacionado VARCHAR(20) NOT NULL DEFAULT '',
  Clase SMALLINT NOT NULL DEFAULT 0
);

CREATE TABLE RelacionesIVARetenido (
 NumeroRetencion decimal (14, 0) PRIMARY KEY NOT NULL ,
 Fecha datetime NOT NULL ,
 Operador varchar (20) NOT NULL ,
 AnhoFiscal int (4) NOT NULL ,
 Mes int (2) NOT NULL ,
 RifProveedor varchar (13) NOT NULL ,
 NombreProveedor nvarchar (50) NOT NULL
);

CREATE TABLE documentosfiscales (
  Id bigint(20) NOT NULL auto_increment,
  Fecha date NOT NULL default '0000-00-00',
  TipoDoc varchar(3) NOT NULL default '',
  NumeroDoc bigint(9) NOT NULL default '0',
  TipoEntidad varchar(3) NOT NULL default '',
  CodigoEntidad varchar(20) NOT NULL default '',
  Referencia varchar(20) NOT NULL default '',
  NumeroControlInicial bigint(20) NOT NULL default '0',
  NumeroControlFinal bigint(20) NOT NULL default '0',  
  FacturaRelacionada varchar(20) NOT NULL default '',
  Exento decimal(18,2) NOT NULL default '0.00',
  Gravable1 decimal(18,2) NOT NULL default '0.00',
  Tasa1 double(6,2) NOT NULL default '0.00',
  Gravable2 decimal(18,2) NOT NULL default '0.00',
  Tasa2 double(6,2) NOT NULL default '0.00',
  Impuesto1 decimal(18,2) NOT NULL default '0.00',
  Impuesto2 decimal(18,2) NOT NULL default '0.00',
  Retencion decimal(18,2) NOT NULL default '0.00',
  TipoDocFiscal varchar(3) NOT NULL, 
  RifEntidad varchar(14) NOT NULL default '',
  NombreEntidad varchar(50) NOT NULL default '',
  Relacionado bigint(14) NOT NULL default 0,
  PRIMARY KEY  (Id),
  KEY DocumentosEntidad (TipoEntidad,CodigoEntidad,Fecha,Id),
  KEY Documentos (TipoDoc,NumeroDoc),
  KEY DocumentosDocumento(TipoEntidad, CodigoEntidad, TipoDoc, Referencia),
);

CREATE INDEX Documentos_Fiscales_DocumentosEntidad  ON DocumentosFiscales (TipoEntidad, CodigoEntidad, Fecha, Id);
CREATE INDEX DocumentosFIscales_Documentos ON DocumentosFiscales (TipoDoc, NumeroDoc);
CREATE INDEX DocumentosFiscales_Relacion ON DocumentosFiscales (Relacionado, NumeroDoc);