-- Probada con SQL Server 2000 (QueryAnalizer) y con SQL Server 2005 Express (SQLS Management Studio)
-- 13/02/2007 lag
create table NNEEDevoluciones (
	Numero bigint IDENTITY (1, 1) PRIMARY KEY NOT NULL,
	FechaRegistro datetime NOT NULL DEFAULT getdate(),
	Operador nvarchar (8),
	FechaTransaccion datetime NOT NULL,
	Almacen nvarchar (12), 
	CodigoCliente nvarchar (20), 
	Descripcion nvarchar (50), 
	ValorPrecioVenta MONEY,
	CostoDevuelto MONEY
);

CREATE  INDEX IX_Cliente ON NNEEDevoluciones (CodigoCliente, Numero);

create table NNEEDevDetalles (
	NumeroDevolucion BIGINT NOT NULL,
	NumeroDetalle INT NOT NULL,
	CodigoItem NVARCHAR (20),
	Cantidad FLOAT, 
	Presentacion NVARCHAR (12),
	FactorEmpaque FLOAT, 
	PrecioUnitario MONEY, 
	CostoUnitario MONEY,
	NumeroNota BIGINT
);

ALTER TABLE NNEEDevDetalles WITH NOCHECK ADD 
	CONSTRAINT PK_NNEEDevDetalles PRIMARY KEY  CLUSTERED 
	(
		NumeroDevolucion,
		NumeroDetalle
	);

	CREATE INDEX IX_DevolucionNota ON NNEEDevDetalles (NumeroNota, NumeroDevolucion, NumeroDetalle);
	
ALTER TABLE NNEEDevDetalles ADD CONSTRAINT FK_NNEEDevDetalles_NNEEDevoluciones
	FOREIGN KEY (NumeroDevolucion) REFERENCES NNEEDevoluciones (Numero) ON DELETE CASCADE  ON UPDATE CASCADE;


