IF NOT Exists(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'RetencionesISLR' AND COLUMN_NAME = 'ConceptoRetencion')
BEGIN
	DROP TABLE RetencionesISLR
	
	CREATE TABLE RetencionesISLR (
		Numero int IDENTITY (1, 1) PRIMARY KEY NOT NULL , 
		tipoEntidadRelacionada nvarchar (3) NOT NULL , 
		codigoEntidad nvarchar (20) NOT NULL , 
		fecha datetime NOT NULL , 
		refDocumento nvarchar (20) NOT NULL , 
		totalPagado money NOT NULL DEFAULT 0, 
		baseImponible money NOT NULL DEFAULT 0, 
		porcentajeRetencion float NOT NULL DEFAULT 0 , 
		montoRetenido money NOT NULL DEFAULT 0,
		numRef int NULL DEFAULT 0,
		TipoDoc NVARCHAR (3) NOT NULL DEFAULT '',
		NumDoc INT NOT NULL DEFAULT 0, 
		RIFSujeto NVARCHAR(15) NOT NULL DEFAULT '',
		NombreSujeto NVARCHAR(50) NOT NULL DEFAULT '',
		DireccionSujeto NVARCHAR(160) NOT NULL DEFAULT '',
		ConceptoRetencion INT NOT NULL DEFAULT 0,
		TipoPersona TINYINT NOT NULL DEFAULT 0)
	
	CREATE INDEX retDocOrigen ON RetencionesISLR (TipoDoc, NumDoc)
	CREATE  INDEX FechaProv ON RetencionesISLR(Fecha, tipoEntidadRelacionada, codigoEntidad) 
	CREATE  INDEX ProvFecha ON RetencionesISLR(tipoEntidadRelacionada, codigoEntidad, Fecha) 
	CREATE INDEX ixRIF ON RetencionesISLR(RIFSujeto, Numero)
END

IF NOT EXISTS(select * from information_schema.columns where table_name = 'ParametrosEmpresa' And column_name='CuentaIvaCompras')
	ALTER TABLE ParametrosEmpresa ADD CuentaIVACompras NVARCHAR(20) NOT NULL DEFAULT ''

IF NOT EXISTS(select * from information_schema.columns where table_name = 'CONTADORES' And column_name='NotaFiscal')
	ALTER TABLE Contadores ADD NotaFiscal INT NOT NULL Default 1

IF NOT EXISTS(select * from information_schema.columns where table_name = 'CONTADORES' And column_name='RetencionISLR')
	ALTER TABLE Contadores ADD RetencionISLR INT NOT NULL Default 1
