Public Sub Main()

	If MsgBox("La siguiente actualizacin elimina toda la informacin registrada" & vbCrLf & _
		"acerca de las Retenciones de ISLR realizadas a nuestros proveedores." & vbCrLf & _
		"Desea continuar?", vbYesNo + vbDefaultButton2, "Actualizacion 6.4.30") = vbNo Then Exit Sub

	With CrearObjeto("Database")
		.Execute "ALTER TABLE Contadores ADD RetencionISLR INT NOT NULL DEFAULT 1"
	
		.Execute "ALTER TABLE Contadores ADD ProximaRelacionIR BIGINT NOT NULL DEFAULT 1"
	
		.Execute "CREATE TABLE rislrConceptos (" & _
			"Id int PRIMARY KEY NOT NULL, " & _
			"Codigo nvarchar (50), " & _
			"Descripcion nvarchar (70), " & _
			"Referencia nvarchar (50), " & _
			"orden smallint NULL)"
	
		.Execute "CREATE UNIQUE INDEX IX_rislrConceptos ON rislrConceptos (Codigo)"
	
		.Execute "CREATE TABLE rislrMetodos (" & _
			"Id int IDENTITY (1, 1) PRIMARY KEY NOT NULL, " & _
			"IdConcepto int NULL, " & _
			"TipoPersona tinyint NULL, " & _
			"TipoMetodo tinyint NULL, " & _
			"PorcentajeBase float NULL, " & _
			"MontoMinimo money NULL, " & _
			"Deducible money NULL, " & _
			"Limite money NULL, " & _
			"Porcentaje float NULL)"
	
		.Execute "CREATE UNIQUE INDEX IX_rislrMetodos ON rislrMetodos(IdConcepto, TipoPersona)"
	
		.Execute "CREATE TABLE rislrParametrosT2 (" & _
			"id int IDENTITY (1,1) PRIMARY KEY NOT NULL," & _
			"idMetodo int NULL,"  & _
			"Hasta money NULL," & _
			"Unidad bit NOT NULL," & _
			"Porcentaje float NULL)"
			
		.Execute "CREATE INDEX IX_rislrParametrosT2 ON rislrParametrosT2(idMetodo, Hasta)"
	
		.Execute "CREATE TABLE rislrParametrosT3 (id int IDENTITY (1,1) NOT NULL, idMetodo int NULL, Archivo nvarchar (128))"
	
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (1, 'HONORARIOS', 'Honorarios profesionales', '1,a', 1)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (2, 'COMISIONES', 'Comisiones pagadas', '2', 3)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (3, 'INTERES1', 'Intereses en creditos invertidos', '3,a', 5)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (4, 'INTERES2', 'Intereses en prestamos de capital', '3,c', 9)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (5, 'NOTICIAS', 'Pagos a agencias de noticias internacionales', '4', 10)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (6, 'FLETESINT', 'Fletes internacionales', '5', 11)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (7, 'FLETESNAC', 'Fletes nacionales', '5', 4)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (8, 'PELICULAS', 'Exhibicion de peliculas', '6', 12)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (9, 'REGALIAS', 'Regalias y similares', '7,1', 13)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (10, 'ASISTEC', 'Asistencia tecnica', '7,2', 14)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (11, 'SERVTEC', 'Servicios tecnologicos', '7,3', 15)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (12, 'SEGUROS', 'Primas de seguros', '8',	16)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (13, 'JUEGOS', 'Ganancias en juegos o apuestas', '9',	17)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (14, 'LOTERIAS', 'Ganancias en loterias o hipodromos', '9', 18)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (15, 'SERVICIOS', 'Ejecucion de obras y servicios', '11', 2)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (16, 'ALQUILERES', 'Arrendamiento de inmuebles', '12', 8)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (17, 'LEASING', 'Arrendamiento de bienes muebles', '13', 7)"
		.Execute "INSERT INTO rislrConceptos (id, Codigo, Descripcion, Referencia, Orden) VALUES (18, 'PUBLICIDAD', 'Publicidad, propaganda y venta de espacios', '19', 6)"
	
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 0, 1, 100.00, 83.33, 2.50, 0.00, 3.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 2, 1, 100.00, 0.54, 0.00, 0.00, 5.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (1, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 0, 1, 100.00, 83.33, 2.50, 0.00, 3.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 2, 1, 100.00, 0.54, 0.00, 0.00, 5.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (2, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (3, 1, 1, 95.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (3, 3, 2, 95.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 0, 1, 100.00, 83.33, 2.50, 0.00, 3.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 2, 1, 100.00, 0.54, 0.00, 0.00, 5.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (4, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (5, 3, 2, 15.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (6, 3, 2, 5.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 3, 2, 10.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (8, 1, 1, 0.54, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (8, 3, 2, 0.54, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (9, 1, 1, 90.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (9, 3, 2, 90.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (10, 1, 1, 30.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (10, 3, 2, 30.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (11, 1, 1, 50.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (11, 3, 2, 50.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (12, 3, 1, 30.00, 0.00, 0.00, 0.00, 10.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 0, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 2, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (13, 3, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 0, 1, 100.00, 0.00, 0.00, 0.00, 16.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 1, 1, 100.00, 0.00, 0.00, 0.00, 16.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 2, 1, 100.00, 0.00, 0.00, 0.00, 16.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (14, 3, 1, 100.00, 0.00, 0.00, 0.00, 16.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 0, 1, 100.00, 83.33, 0.83, 0.00, 1.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 2, 1, 100.00, 0.00, 0.00, 0.00, 2.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (15, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 0, 1, 100.00, 83.33, 2.50, 0.00, 3.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 2, 1, 100.00, 0.54, 0.00, 0.00, 5.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (16, 3, 2, 100.00, 0.00, 0.00, 0.00, 0.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 0, 1, 100.00, 83.33, 2.50, 0.00, 3.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 2, 1, 100.00, 0.54, 0.00, 0.00, 5.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 1, 1, 100.00, 0.00, 0.00, 0.00, 34.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (17, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 0, 1, 100.00, 83.33, 0.00, 0.00, 1.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (7, 2, 1, 100.00, 0.54, 0.00, 0.00, 3.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 0, 1, 100.00, 83.33, 2.50, 0.00, 3.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 2, 1, 100.00, 0.54, 0.00, 0.00, 5.00)"
		.Execute "INSERT INTO rislrMetodos (idConcepto, TipoPersona, TipoMetodo, PorcentajeBase, MontoMinimo, Deducible, Limite, Porcentaje) VALUES (18, 3, 1, 100.00, 0.00, 0.00, 0.00, 5.00)"
	
		.Execute "INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 2000.00, 1, 22.00)"
		.Execute "INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 3000.00, 1, 34.00)"
		.Execute "INSERT INTO rislrparametrosT2(idMetodo, Hasta, Unidad, Porcentaje) VALUES (2, 0.00, 1, 15.00)"
	
		.Execute "DROP TABLE RetencionesISLR"
		
		.Execute "CREATE TABLE RetencionesISLR (" & _
			"Numero int IDENTITY (1, 1) PRIMARY KEY NOT NULL ," & _
			"tipoEntidadRelacionada nvarchar (3) NOT NULL ," & _
			"codigoEntidad nvarchar (20) NOT NULL ," & _
			"fecha datetime NOT NULL ," & _
			"refDocumento nvarchar (20) NOT NULL , " & _
			"totalPagado money NOT NULL DEFAULT 0, " & _
			"baseImponible money NOT NULL DEFAULT 0, " & _
			"porcentajeRetencion float NOT NULL DEFAULT 0 , " & _
			"montoRetenido money NOT NULL DEFAULT 0," & _
			"numRef int NULL DEFAULT 0," & _
			"TipoDoc NVARCHAR (3) NOT NULL DEFAULT ''," & _
			"NumDoc INT NOT NULL DEFAULT 0, " & _
			"RIFSujeto NVARCHAR(15) NOT NULL DEFAULT ''," & _
			"NombreSujeto NVARCHAR(50) NOT NULL DEFAULT ''," & _
			"DireccionSujeto NVARCHAR(160) NOT NULL DEFAULT ''," & _
			"ConceptoRetencion INT NOT NULL DEFAULT 0," & _
			"TipoPersona TINYINT NOT NULL DEFAULT 0)"
		
		.Execute "CREATE INDEX retDocOrigen ON RetencionesISLR (TipoDoc, NumDoc)"
		.Execute "CREATE  INDEX FechaProv ON RetencionesISLR(Fecha, tipoEntidadRelacionada, codigoEntidad)"
		.Execute "CREATE  INDEX ProvFecha ON RetencionesISLR(tipoEntidadRelacionada, codigoEntidad, Fecha)"
		.Execute "CREATE INDEX ixRIF ON RetencionesISLR(RIFSujeto, Numero)"
	
		.Execute "ALTER TABLE ParametrosEmpresa ADD CuentaIVACompras NVARCHAR(20) NOT NULL DEFAULT ''"
	
		.Execute "ALTER TABLE Contadores ADD NotaFiscal INT NOT NULL Default 1"
	
		.Execute "ALTER TABLE Contadores ADD RetencionISLR INT NOT NULL Default 1"
	End With

	MsgBox "Listo", vbInformation, "Actualizar a version 6.4.30"
End Sub
