ALTER TABLE AnulacionesPOS ADD ID INT IDENTITY PRIMARY KEY,
			IDMaquina INT NOT NULL DEFAULT 0,
			numFactura INT NOT NULL DEFAULT 0
GO

CREATE TABLE DetallesAnulacionPOS (
	idDetalle bigint IDENTITY (1, 1) PRIMARY KEY NOT NULL, 
	numDevol int NOT NULL, Producto nvarchar (20) NOT NULL, Cantidad float NOT NULL, 
	PrecioUnitario money NOT NULL, PorcentajeImpuesto float NOT NULL, Usuario nvarchar (20))
GO

CREATE  INDEX IX_DetallesAnul ON DetallesAnulacionPOS(numDevol, idDetalle)

ALTER TABLE DetallesAnulacionPOS ADD CONSTRAINT FK_DetallesAnulacionPOS_AnulacionesPOS FOREIGN KEY 
	(numDevol) REFERENCES AnulacionesPOS (ID) ON DELETE CASCADE

INSERT INTO Clientes (Codigo, Nombre, RIF, NIT, Direccion, CondicionStandard, 
	PrecioStandard, FechaUltimaVenta, IndicePrecio, Telefono, Zona, VendedorAsignado, 
	Notas, Contribuyente, ContribuyenteEspecial, Tipo) 
SELECT Codigo, Nombre, LEFT(RIF, 12), Nit, Direccion, 'CONTADO', TituloPrecio1, '20000101', 1, '', '', '', '', 0, 0, ''
	FROM ClientesPOS, (SELECT TOP 1 TituloPrecio1 FROM ParametrosEmpresa) AS T 
	WHERE NOT ClientesPOS.Codigo IN (SELECT Codigo FROM Clientes)
