Public Sub Main()

	With CrearOBjeto("Database")
		.Execute "CREATE TABLE CobrosPostdatados(" & _
						  "Numero int IDENTITY(1,1) PRIMARY KEY NOT NULL, CodigoCliente nvarchar(20) NOT NULL, CodigoVendedor nvarchar(20) NOT NULL, " & _
							"FechaPresentacion datetime NOT NULL, Descripcion nvarchar(50) NOT NULL, FechaRegistro datetime NOT NULL DEFAULT (getdate()))"

		.Execute "CREATE INDEX IX_CobrosPostdatadosFecha ON CobrosPostdatados (FechaPresentacion ASC)"

		.Execute "CREATE TABLE CobrosPostdatadosDetalles(" & _
							"Numero int IDENTITY(1,1) PRIMARY KEY NOT NULL, idCobro int NOT NULL, TotalAbono money NOT NULL, ValorRecibido money NOT NULL, " & _
							"RetencionIVA money NOT NULL, ComprobanteRetencion money NOT NULL, FechaRetencion datetime NOT NULL, RetencionISLR money NOT NULL, " & _
							"NumeroComprobanteISLR int NOT NULL, MontoDescuento money NOT NULL, NumeroControlNC nvarchar(16) NOT NULL, NumDoc int NOT NULL, " & _
							"TipoDoc nvarchar(3) NULL)"
		.Execute "CREATE TABLE CobrosPostdatadosMedios(" & _
							"Numero bigint IDENTITY(1,1) PRIMARY KEY NOT NULL, idCobro int NOT NULL, Detalle nvarchar(1024) NOT NULL)"
		.Execute "CREATE INDEX IX_CobrosPostdatadosMedios ON CobrosPostdatadosMedios (idCobro ASC)"

		.Execute "ALTER TABLE CobrosPostdatadosDetalles " & _
							"ADD CONSTRAINT FK_CobrosPostdatadosDetalles_CobrosPostdatados FOREIGN KEY(idCobro) " & _
							"REFERENCES CobrosPostdatados (Numero) " & _
							"ON DELETE CASCADE"

		.Execute "ALTER TABLE CobrosPostdatadosMedios " & _
							"ADD CONSTRAINT FK_CobrosPostdatadosMedios_CobrosPostdatados FOREIGN KEY(idCobro) " & _
							"REFERENCES CobrosPostdatados (Numero) " & _
							"ON DELETE CASCADE"
	End With
	
	MsgBox "Listo!", vbOkOnly, "ClearLight: Upgrade V6.7.1"
End Sub

