CREATE FUNCTION dbo.ExistenciaFecha
(
	@Fecha DATETIME
)
RETURNS @valores TABLE
  ( 
	codigo nvarchar(20),
	existencia float
   )
AS
BEGIN
	DECLARE @indicePeriodo INT
	DECLARE @PrimerDiaMes DATETIME
	SET @PrimerDiaMes = DATEADD(d, -(DAY(@Fecha) - 1), @Fecha)
	SET @IndicePeriodo = YEAR(@Fecha) * 100 + MONTH(@Fecha)
	INSERT @valores
		SELECT codigoEntidad, SUM(valor) FROM 
		(
			SELECT CodigoEntidad, SUM(Balance) As Valor
				FROM BalancesMensuales
				WHERE TipoEntidad = 'INV'
				AND IndicePeriodo < @indicePeriodo
				GROUP BY CodigoEntidad
			UNION SELECT CodigoItem, SUM((Entradas - Salidas))
				FROM DetallesMinv
				WHERE FechaOperacion BETWEEN @PrimerDiaMes AND DATEADD(d, -1, @Fecha)
				GROUP BY CodigoItem
		) T
		GROUP BY CodigoEntidad
	RETURN
END
GO

CREATE FUNCTION dbo.ValoracionFecha
(
	@Fecha DATETIME
)
RETURNS @valores TABLE
  ( 
	codigo nvarchar(20),
	existencia float
   )
AS
BEGIN
	DECLARE @indicePeriodo INT
	DECLARE @PrimerDiaMes DATETIME
	SET @PrimerDiaMes = DATEADD(d, -(DAY(@Fecha) - 1), @Fecha)
	SET @IndicePeriodo = YEAR(@Fecha) * 100 + MONTH(@Fecha)
	INSERT @valores
		SELECT codigoEntidad, SUM(valor) FROM 
		(
			SELECT CodigoEntidad, SUM(Balance) As Valor
				FROM BalancesMensuales
				WHERE TipoEntidad = 'VIV'
				AND IndicePeriodo < @indicePeriodo
				GROUP BY CodigoEntidad
			UNION SELECT CodigoItem, SUM((Entradas - Salidas) * Costo)
				FROM DetallesMinv
				WHERE FechaOperacion BETWEEN @PrimerDiaMes AND DATEADD(d, -1, @Fecha)
				GROUP BY CodigoItem
		) T
		GROUP BY CodigoEntidad
	RETURN
END
GO