CREATE TABLE nomPrestamos(
	numero int IDENTITY(1,1) PRIMARY KEY NOT NULL,
	fecha datetime NOT NULL,
	trabajador nvarchar(20) NOT NULL,
	descripcion nvarchar(50) NOT NULL,
	fechaRegistro datetime NOT NULL CONSTRAINT DF_nomPrestamos_fechaRegistro  DEFAULT (getdate()),
	operador nvarchar(8) NOT NULL,
	monto money NOT NULL,
	saldo money NOT NULL,
)
GO
CREATE INDEX IX_nomPrestamos_Trabajador ON nomPrestamos (trabajador)
GO

CREATE TABLE nomPagosPrestamo(
	id bigint IDENTITY(1,1) PRIMARY KEY NOT NULL,
	idPrestamo int NOT NULL,
	numProceso int NOT NULL,
	fecha datetime NOT NULL,
	montoPagado money NOT NULL,
)
GO
ALTER TABLE nomPagosPrestamo  WITH CHECK ADD  CONSTRAINT FK_nomPagosPrestamo_nomPrestamos FOREIGN KEY(idPrestamo)
REFERENCES nomPrestamos (numero)
ON UPDATE CASCADE
ON DELETE CASCADE
GO
ALTER TABLE nomPagosPrestamo CHECK CONSTRAINT FK_nomPagosPrestamo_nomPrestamos
GO
CREATE INDEX IX_nomPagosPrestamoPrestamo ON nomPagosPrestamo (idPrestamo)
GO

CREATE TABLE nomParametrosPrestamo(
	id bigint IDENTITY(1,1) PRIMARY KEY NOT NULL,
	idPrestamo int NOT NULL,
	codigoProceso nvarchar(20) NOT NULL,
	porcentaje float NOT NULL,
)
GO
CREATE INDEX IX_nomParametrosPrestamoPrestamo ON nomParametrosPrestamo (idPrestamo)
GO
ALTER TABLE nomParametrosPrestamo  WITH CHECK
	ADD  CONSTRAINT FK_nomParametrosPrestamo_nomPrestamos FOREIGN KEY(idPrestamo)
	REFERENCES nomPrestamos (numero)
GO

CREATE VIEW nomDetallesPrestamo
AS
	select 
	  r.numero, r.saldo, r.trabajador, 0 as seq, r.fecha, r.descripcion, r.operador, r.monto as DB, 0 as cr
	  from nomPrestamos r
	union select
	  idprestamo, 0, pres.trabajador, id, p.fecha, 'Proceso ' + codigoscript, nomProcesos.operador, 0, montopagado
	  from nomPagosPrestamo p inner join nomProcesos 
	  on nomProcesos.numero = numProceso
		inner join nomPrestamos pres
		on pres.numero = idPrestamo
