Alter Table RenglonesSesion
  ADD PrecioOriginal FLOAT Default 0
GO
UPDATE RenglonesSesion SET PrecioOriginal = PrecioUnitario

ALTER TABLE Clientes
  ADD PerfilPrecios NVARCHAR(12) NOT NULL DEFAULT 'PRECIO1'
GO

CREATE TABLE perfilesPrecios (
  codigoPerfil nvarchar (12) PRIMARY KEY NOT NULL ,
  descripcion nvarchar (30)  NOT NULL ,
  indicePrecioBase tinyint NOT NULL ,
  porcentajeDescuento1 float NOT NULL ,
  porcentajeDescuento2 float NOT NULL ,
  baseDescuentoLinea tinyint NOT NULL ,
  isStrict tinyint not null default 0
)
GO

CREATE TABLE detallesPerfilPrecio (
	idDetalle int IDENTITY (1, 1) PRIMARY KEY NOT NULL ,
	codigoPerfil nvarchar (12)  NOT NULL ,
	valorInicial nvarchar (20)  NOT NULL ,
	valorFinal nvarchar (20)  NOT NULL ,
	pDesc float NOT NULL ,
	CONSTRAINT FK_detallesPerfilPrecio_perfilesPrecio FOREIGN KEY 
	(
		codigoPerfil
	) REFERENCES perfilesPrecios (
		codigoPerfil
	) ON DELETE CASCADE  ON UPDATE CASCADE 
)
GO

INSERT INTO perfilesPrecios
   (CodigoPerfil, descripcion, indicePrecioBase, porcentajeDescuento1, porcentajeDescuento2, baseDescuentoLinea)
SELECT TOP 1
    'PRECIO1', TituloPrecio1, 1, 0, 0, 0
FROM parametrosEmpresa

INSERT INTO perfilesPrecios
   (CodigoPerfil, descripcion, indicePrecioBase, porcentajeDescuento1, porcentajeDescuento2, baseDescuentoLinea)
SELECT TOP 1
    'PRECIO2', TituloPrecio2, 2, 0, 0, 0
FROM parametrosEmpresa

INSERT INTO perfilesPrecios
   (CodigoPerfil, descripcion, indicePrecioBase, porcentajeDescuento1, porcentajeDescuento2, baseDescuentoLinea)
SELECT TOP 1
    'PRECIO3', TituloPrecio3, 3, 0, 0, 0
FROM parametrosEmpresa

INSERT INTO perfilesPrecios
   (CodigoPerfil, descripcion, indicePrecioBase, porcentajeDescuento1, porcentajeDescuento2, baseDescuentoLinea)
SELECT TOP 1
    'PRECIO4', TituloPrecio4, 4, 0, 0, 0
FROM parametrosEmpresa

UPDATE Clientes
SET PerfilPrecios = 'PRECIO' + CONVERT(NVARCHAR(1), indicePrecio)

GO

CREATE FUNCTION FechaEntera(@arg As DATETIME)
RETURNS DATETIME
AS
BEGIN
	RETURN CONVERT(DATETIME, FLOOR(CONVERT(FLOAT, @arg)))
END

GO
