ALTER TABLE itemsInventario
	ADD peso FLOAT not null default 0
GO

ALTER TABLE generalEmisores
	ALTER COLUMN codigoEmisor NVARCHAR(20)
GO

DELETE FROM GeneralEmisores

INSERT INTO generalEmisores (tipoDocumento, codigoEmisor)
  SELECT DISTINCT Medio, Emisor 
  FROM detallesIngresoCaja
  WHERE NOT Emisor IS NULL And Emisor != ''
GO

CREATE FUNCTION pesoFactura(@numFac INTEGER)
RETURNS FLOAT 
AS
BEGIN
DECLARE @retVal FLOAT
	select @retVal = COALESCE(sum(i.peso * c.cantidad * d.cantidad), 0)
	  from (select * from detallesFactura where numeroDocumento = @numFac) d
	  inner join itemsVenta v on v.codigo = d.codigoitem
	  inner join composicionitemsventa c on c.codigoitemventa = v.codigo
	  inner join itemsInventario i on i.codigo = c.codigoItemInventario
	return @retVal
END
GO
