-- *********************************************
-- *********** NOTA IMPORTANTE!!! ***********
-- *********************************************
--
-- Debe asignarse a @serieDefault el cdigo de la serie a la que correspondern TODAS
-- las notas de debito/credito emitidas con un correlativo nico.
--
-- Por favor tome en cuenta que este script est formado por TRES SECUENCIAS DE INSTRUCCIONES
-- y que la asignacin del valor correcto a @serieDefault tiene que hacerse en las tres.
-- Si su herramienta SQL soporta el reemplazo de texto, reemplace 'ESCRIBA AQUI EL CONDIGO DE LA SERIE'
-- por el cdigo de la serie deseada delimitado por apostrofes (i.e. 'DIR').
--
-- *********************************************

	ALTER TABLE Series
	  ADD ProximaNota INT NOT NULL DEFAULT 1

	ALTER TABLE NotasDCCP
	  ADD Serie NVARCHAR(3) NOT NULL DEFAULT '',
		  correlativoSerie INT NOT NULL DEFAULT 1
	GO
	
	CREATE INDEX ndx_Serie ON NotasDCCP (serie, correlativoSerie)

DECLARE @serieDefault NVARCHAR(3)
DECLARE @existeSerie INT

SET @serieDefault = 'A'

SET @existeSerie = (SELECT COUNT(*) FROM Series WHERE CodigoSerie = @serieDefault)
IF @existeSerie = 0
  RAISERROR('CODIGO DE SERIE INVALIDO, POR FAVOR EDITE EL SCRIPT', 17, 1)
ELSE BEGIN
	UPDATE NotasDCCP 
	  SET Serie = @serieDefault,
		  correlativoSerie = Correlativo
	WHERE TipoEntidad = 'CLT'
	  AND Correlativo != 0

	UPDATE Series
	   SET ProximaNota = maxSerie
	   FROM (SELECT COALESCE(MAX(correlativoSerie), 0) + 1 AS MaxSerie FROM NotasDCCP) T
	   WHERE codigoSerie = @serieDefault
END
