CREATE TABLE mensajesInternos(
	id int IDENTITY(1,1) PRIMARY KEY NOT NULL,
	emisor nvarchar(8) NOT NULL,
	fechaCreacion datetime NOT NULL DEFAULT getdate(),
	asunto nvarchar(50) NOT NULL,
	contenido text NOT NULL,
	adjuntos text NOT NULL,
	idOrigen int NOT NULL DEFAULT 0
)

GO


CREATE TABLE mensajesLeidos(
	id int NOT NULL,
	destinatario nvarchar(8) NOT NULL,
	fechaLectura datetime NOT NULL DEFAULT getdate()
)

GO

ALTER TABLE dbo.mensajesLeidos  WITH CHECK ADD  CONSTRAINT FK_mensajesLeidos_mensajesInternos FOREIGN KEY(id)
REFERENCES dbo.mensajesInternos (id)
ON UPDATE CASCADE
ON DELETE CASCADE
GO

CREATE TABLE mensajesPendientes(
	id int NOT NULL,
	destinatario nvarchar(8) NOT NULL
)

GO

ALTER TABLE dbo.mensajesPendientes  WITH CHECK ADD  CONSTRAINT FK_mensajesPendientes_mensajesInternos FOREIGN KEY(id)
REFERENCES dbo.mensajesInternos (id)
ON UPDATE CASCADE
ON DELETE CASCADE
GO

ALTER TABLE dbo.mensajesPendientes  WITH CHECK ADD  CONSTRAINT FK_mensajesPendientes_Usuarios FOREIGN KEY(destinatario)
REFERENCES dbo.Usuarios (Codigo)
ON UPDATE CASCADE
ON DELETE CASCADE
GO

ALTER TABLE mnuItems ADD extDesc TEXT not null default ''
GO

ALTER TABLE cuentasPOS ADD bloqueada INT NOT NULL DEFAULT 0
GO
