DECLARE @n INT

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.Columns WHERE TABLE_NAME = 'Proveedores' AND Column_Name = 'tipoPersona')
BEGIN
  ALTER TABLE Proveedores ADD tipoPersona TINYINT NOT NULL Default 2
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.Columns WHERE TABLE_NAME = 'Usuarios' AND Column_Name = 'uniqid')
BEGIN
  ALTER TABLE Usuarios ADD uniqid NVARCHAR(23) NOT NULL Default ''
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.Columns WHERE TABLE_NAME = 'Usuarios' AND Column_Name = 'TEMA')
BEGIN
  ALTER TABLE Usuarios ADD tema NVARCHAR(20) NOT NULL DEFAULT 'Default'
END


IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.Columns WHERE TABLE_NAME = 'NNEEDevDetalles' AND Column_Name = 'RENGLON')
BEGIN
  ALTER TABLE NNEEDevDetalles ADD Renglon INT NOT NULL DEFAULT 0
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.Columns WHERE TABLE_NAME = 'Vendedores' AND Column_Name = 'cuentaPasivo')
BEGIN
  ALTER TABLE Vendedores ADD cuentaPasivo NVARCHAR(20) NOT NULL DEFAULT ''
END

IF NOT EXISTS(SELECT * FROM information_schema.tables where table_name = 'nomParametrosGenerales')
BEGIN
  Create Table nomParametrosGenerales (
    sueldoMinimo MONEY Not Null Default 0
  )
  INSERT INTO nomParametrosGenerales (sueldoMinimo) VALUES (2456.4)
END

IF NOT Exists(SELECT * FROM INFORMATION_SCHEMA.Columns WHERE TABLE_NAME = 'nomTrabajadores' AND Column_Name = 'ganaSueldoMinimo')
BEGIN
  ALTER TABLE nomTrabajadores ADD ganaSueldoMinimo SMALLINT NOT NULL DEFAULT 0
END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.Columns WHERE TABLE_NAME = 'nomTrabajadores' AND COLUMN_NAME = 'cuentaBancaria')
BEGIN
  ALTER TABLE nomTrabajadores ADD cuentaBancaria NVARCHAR(20) NOT NULL DEFAULT ''
END

SET @n = (SELECT Character_Maximum_Length FROM information_schema.columns WHERE Table_Name = 'MediosPago' And Column_Name = 'Descripcion')
IF @n < 40 ALTER TABLE MediosPago ALTER COLUMN Descripcion NVARCHAR(40)

-- Creacion de la tabla de eliminacion de detallesPOS

IF Not Exists (SELECT * FROM information_schema.tables where table_name = 'EliminacionesPOS')
BEGIN
  CREATE TABLE EliminacionesPOS(
	id int IDENTITY(1,1) PRIMARY KEY NOT NULL,
	Sesion int NOT NULL,
	Maquina smallint NOT NULL,
	Cuenta nvarchar(14) NOT NULL DEFAULT '',
	Producto nvarchar(20) NOT NULL,
	Precio money NOT NULL,
	Cantidad float NOT NULL,
	Autorizado nvarchar(12) NOT NULL DEFAULT '',
	Hora datetime NOT NULL DEFAULT getdate(),
	numCta int NOT NULL DEFAULT 0
  )

  CREATE INDEX ix_sesion ON EliminacionesPOS (Sesion)
END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.Columns WHERE TABLE_NAME = 'mnuItems' AND COLUMN_NAME = 'textColor')
BEGIN
  ALTER TABLE mnuItems ADD textColor INT NOT NULL DEFAULT 0
END

IF NOT EXISTS (SELECT * FROM information_schema.tables where table_name = 'saveMovsCaja')
BEGIN
	CREATE TABLE dbo.saveMovsCaja(
		id int IDENTITY(1,1) PRIMARY KEY NOT NULL,
		clave nvarchar(20) NOT NULL
	)
	CREATE UNIQUE NONCLUSTERED INDEX IX_saveMovCaja ON saveMovsCaja (clave)

	CREATE TABLE dbo.saveDetallesCaja(
		id int IDENTITY(1,1) PRIMARY KEY NOT NULL,
		transID int NOT NULL,
		Medio nvarchar(8) NOT NULL,
		Emisor nvarchar(20) NOT NULL,
		numeroDocumento nvarchar(20) NOT NULL,
		claveAutorizacion nvarchar(6) NOT NULL,
		monto money NOT NULL,
		numeroCuenta nvarchar(20) NOT NULL,
		idTitular nvarchar(20) NOT NULL,
		montoNominal money NOT NULL
	)

	ALTER TABLE dbo.saveDetallesCaja  WITH CHECK ADD  CONSTRAINT FK_saveDetallesCaja_saveMovCaja FOREIGN KEY(transID)
	REFERENCES dbo.saveMovsCaja (id)
	ON DELETE CASCADE

	CREATE TABLE dbo.saveDenominaciones(
		id bigint IDENTITY(1,1) PRIMARY KEY NOT NULL,
		idDetalle int NOT NULL,
		Denominacion money NOT NULL,
		CantidadRecibida int NOT NULL
	)

	ALTER TABLE dbo.saveDenominaciones  WITH CHECK ADD  CONSTRAINT FK_saveDenominaciones_saveDetallesCaja FOREIGN KEY(idDetalle)
	REFERENCES dbo.saveDetallesCaja (id)
	ON DELETE CASCADE
END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'parametrosEmpresa' AND COLUMN_NAME = 'ClaveActivacionV7')
BEGIN
  ALTER TABLE parametrosEmpresa ADD claveActivacionV7 INT NOT NULL DEFAULT 0
  EXEC SP_EXECUTESQL N'UPDATE parametrosEmpresa SET claveActivacionV7 = claveActivacion'
END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = 'HistoriaIVA')
BEGIN
  CREATE TABLE historiaIVA (
    id  INT IDENTITY(1, 1) PRIMARY KEY NOT NULL,
    tipo TINYINT NOT NULL,
    fechaInicioVigencia DATETIME NOT NULL,
    alicuota float NOT NULL
  )

  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '18000101', 0)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (2, '18000101', 0)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '19931001', 10)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '19950101', 12.5)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '19960801', 16.5)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '20000801', 14.5)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '20020301', 16)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '20040901', 15)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '20051001', 14)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '20070301', 11)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (1, '20090401', 12)
  INSERT INTO historiaIVA (tipo, fechaInicioVigencia, alicuota) VALUES (2, '20051001', 8)
END
GO

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.PARAMETERS WHERE SPECIFIC_NAME = 'IVAFecha')
BEGIN
  exec sp_executesql N'CREATE FUNCTION IVAFecha(@tipo as tinyInt, @Fecha AS DATETIME) 
  RETURNS FLOAT AS
  BEGIN
    DECLARE @retVal FLOAT
    SELECT @retVal = COALESCE(alicuota, 0) 
          FROM historiaIVA WHERE tipo = @tipo AND FechaInicioVigencia = (
              SELECT MAX(FechaInicioVigencia)
              FROM historiaIVA
              WHERE tipo = @tipo 
              AND fechaInicioVigencia <= @fecha
    )
    RETURN @retVal
  END'
END

GO

-- V7.2

IF NOT Exists(select * from information_schema.columns where table_Name = 'mesasMesas' and Column_Name = 'id')
BEGIN
  alter Table mesasMesas
    ADD id int identity (1, 1) NOT NULL
  create unique index ndx_id_mesasMesas ON mesasMesas (id)
END

If Not exists(select * from information_schema.columns WHERE Table_Name = 'cuentasPOS' And column_name = 'ownerID')
BEGIN
	DROP TABLE RenglonesCuentaPOS
	DROP TABLE RenglonesComanda
	DROP TABLE CuentasPOS
	
	CREATE TABLE CuentasPOS (
		IDCuenta int IDENTITY (1, 1) PRIMARY KEY NOT NULL ,
		tipo tinyint NOT NULL DEFAULT 0,
		ownerID INT NOT NULL DEFAULT 0,
		CodigoCuenta nvarchar (20) NOT NULL DEFAULT '',
		HoraApertura datetime NOT NULL DEFAULT getdate(),
		HoraUltimaTransaccion datetime NOT NULL DEFAULT getdate(),
		Vendedor nvarchar (20) NOT NULL DEFAULT '',
		Estado smallint NOT NULL DEFAULT 0,
		Personas int NOT NULL DEFAULT 1,
		Cliente nvarchar (20) NOT NULL DEFAULT '',
		Ambiente nvarchar (16) NOT NULL DEFAULT '',
		idMesa int NOT NULL DEFAULT 0,
		Condiciones nvarchar (12) DEFAULT '' ,
		Extra nvarchar (12) NOT NULL DEFAULT '', 
		Bloqueada INT NOT NULL DEFAULT 0,
		Correlativo int not null default 0,
		codigoDescuento NVARCHAR(12) NOT NULL DEFAULT '',
		autorizadoDescuento NVARCHAR(12) NOT NULL DEFAULT '',
		explicacionDescuento NVARCHAR(80) NOT NULL DEFAULT ''
	) 
	
	CREATE TABLE RenglonesCuentaPOS (
		id BIGINT IDENTITY (1, 1) PRIMARY KEY NOT NULL,
		IDCuenta int NOT NULL DEFAULT 0,
		CodigoItem nvarchar (20) NOT NULL DEFAULT '',
		PrecioUnitario money NOT NULL DEFAULT 0,
		Cantidad float NOT NULL DEFAULT 0,
		NumeroRenglon int NOT NULL DEFAULT 0,
		Usuario nvarchar (20) NULL DEFAULT '',
		Precio money NOT NULL DEFAULT 0,
		idCombo INT NOT NULL DEFAULT 0
	) 
	
	ALTER TABLE RenglonesCuentaPOS ADD CONSTRAINT FK_RenglonesCuentaPOS_CuentasPOS
		FOREIGN KEY (IDCuenta) REFERENCES CuentasPOS (IDCuenta) ON DELETE CASCADE  ON UPDATE CASCADE 

	exec sp_executesql N'CREATE INDEX ndx_CuentaPOS_Owner ON CuentasPOS (tipo, ownerID)'

	CREATE TABLE renglonesComanda (
		numero bigint IDENTITY(1,1) PRIMARY KEY NOT NULL,
		cuenta int NOT NULL,
		codigoItem nvarchar(20) NOT NULL DEFAULT '',
		porcentajeIVA float NOT NULL DEFAULT 0,
		precio money NOT NULL DEFAULT 0,
		cantidad float NOT NULL DEFAULT 0,
		descripcion nvarchar(50) NOT NULL DEFAULT '',
		usuario nvarchar(20) not null default ''
)

	ALTER TABLE renglonesComanda  ADD CONSTRAINT FK_renglonesComanda_CuentasPOS FOREIGN KEY(cuenta)
		REFERENCES CuentasPOS (IDCuenta)
		ON UPDATE CASCADE
		ON DELETE CASCADE
END

-- V7.2: Registro de descuentos

IF NOT Exists(SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = 'MotivosDescuento')
BEGIN
  Create Table MotivosDescuento (
    Codigo NVARCHAR(12) PRIMARY KEY NOT NULL,
    Descripcion NVARCHAR(40) NOT NULL,
    porcentaje float not null default 0,
    respetarMinimos tinyint not null default 1,
    nivelAutorizacion tinyint not null default 1,
    detallesModificables tinyint not null default 0
  )

  Create Table DescuentosSesion (
    id int IDENTITY (1, 1) PRIMARY KEY NOT NULL,
    sesion int not null, 
    codigoMotivo nvarchar(12) NOT NULL DEFAULT 'ERROR', 
    autorizadoDescuento nvarchar(12) NOT NULL DEFAULT 'ERROR',
    explicacionDescuento nvarchar(80) NOT NULL DEFAULT 'ERROR',
    porcentajeDescuento FLOAT NOT NULL DEFAULT 0,
    Hora DATETIME NOT NULL DEFAULT GETDATE(),
    numeroTicket INT NOT NULL DEFAULT 0,
    caja int not null default 0,
    valorOriginal money not null default 0,
    valorFinal money not null default 0
  )

  exec sp_executesql N'CREATE INDEX ndx_DescuentosSesion_Sesion ON DescuentosSesion (Sesion)'

  exec sp_executesql N'alter table DescuentosSesion 
    ADD CONSTRAINT FK_DescuentosSesion_Motivo
      FOREIGN KEY (CodigoMotivo)
      REFERENCES MotivosDescuento (Codigo)
      ON UPDATE CASCADE'
END

GO

-- En el ((ya no tan, aparentemente) improbable) caso de que venga de una beta de la 7.2:
IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'MotivosDescuento' AND COLUMN_NAME = 'detallesModificables')
BEGIN
  ALTER TABLE motivosDescuento
    ADD detallesModificables TINYINT NOT NULL DEFAULT 0
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'MotivosDescuento' AND COLUMN_NAME = 'porcentaje')
BEGIN
  ALTER TABLE motivosDescuento
    ADD porcentaje FLOAT NOT NULL DEFAULT 0
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'MotivosDescuento' AND COLUMN_NAME = 'respetarMinimos')
BEGIN
  ALTER TABLE motivosDescuento
    ADD respetarMinimos TINYINT NOT NULL DEFAULT 1
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'MotivosDescuento' AND COLUMN_NAME = 'nivelAutorizacion')
BEGIN
  ALTER TABLE motivosDescuento
    ADD nivelAutorizacion TINYINT NOT NULL DEFAULT 1
END

GO

IF NOT Exists(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'DescuentosSesion' AND COLUMN_NAME = 'numeroTicket')
BEGIN
  ALTER TABLE DescuentosSesion
    ADD numeroTicket INT NOT NULL DEFAULT 0
END

IF NOT Exists(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'DescuentosSesion' AND COLUMN_NAME = 'caja')
BEGIN
  ALTER TABLE DescuentosSesion
    ADD caja int not null default 0
END
    
IF NOT Exists(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'DescuentosSesion' AND COLUMN_NAME = 'valorOriginal')
BEGIN
  ALTER TABLE DescuentosSesion
    ADD valorOriginal money not null default 0
END
    
IF NOT Exists(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'DescuentosSesion' AND COLUMN_NAME = 'valorFinal')
BEGIN
  ALTER TABLE DescuentosSesion
    ADD valorFinal money not null default 0
END

GO

-- El descuento general se usa para registrar descuentos no-definidos, otorgados
-- desde aplicaciones que no usen los descuentos predefinidos (a la fecha, todas
-- menos clrCaja4)
IF NOT EXISTS(SELECT * FROM MotivosDescuento WHERE Codigo = 'GENERAL')
BEGIN
  INSERT INTO MotivosDescuento (Codigo, Descripcion, porcentaje, respetarMinimos, nivelAutorizacion, detallesModificables)
       VALUES ('GENERAL', 'Descuento general', 0, 1, 5, 1)
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'CuentasPOS' AND COLUMN_NAME = 'codigoDescuento')
BEGIN
  ALTER TABLE CuentasPOS
     ADD codigoDescuento NVARCHAR(12) NOT NULL DEFAULT '',
	 autorizadoDescuento NVARCHAR(12) NOT NULL DEFAULT '',
	 explicacionDescuento NVARCHAR(80) NOT NULL DEFAULT ''
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 60)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 60 , 'Taller de reparaciones', 2510);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 61)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 61 , 'Modificar configuraciones de color', 976);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 62)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 62 , 'Seleccionar configuracion de color', 977);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 63)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 63 , 'Operar editor de menues', 605);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 64)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 64 , 'Editar tipos de descuento', 3810);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 65)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 65 , 'Editar perfiles de precios', 3820);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 66)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 66 , 'Definir medios de pago', 4050);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 67)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 67 , 'Editar libro de ventas', 2520);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 68)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 68 , 'Editar libro de compras', 4050);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 69)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 69 , 'Anotar retenciones IVA clientes', 2530);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 70)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 70 , 'Generar comprobantes de retencion', 1840);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 71)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 71 , 'Registrar retenciones del ISLR', 1841);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 72)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 72 , 'Ejecutar procesos de nomina', 4511);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 73)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 73 , 'Ejecutar scripts', 3500);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 74)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 74 , 'Ver reporte de excepciones', 2651);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 75)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 75 , 'Ver reportes de nomina', 3410);
END

IF NOT Exists(SELECT * FROM PerfilElementos WHERE Valor = 76)
BEGIN
	INSERT INTO perfilElementos (Valor, Descripcion, Posicion) VALUES ( 76 , 'Operar tabla de productos', 650);
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = 'extDesc')
BEGIN
  CREATE TABLE extDesc (
    codigoItem NVARCHAR(20) PRIMARY KEY NOT NULL DEFAULT '',
    value NVARCHAR(4000) NOT NULL DEFAULT ''
  );
  
  exec sp_executesql N'alter table extDesc 
    ADD CONSTRAINT FK_ExtDesc_ItemsVenta
      FOREIGN KEY (codigoItem)
      REFERENCES itemsVenta (Codigo)
      ON UPDATE CASCADE ON DELETE CASCADE'
END

GO 

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = 'tmpTransferencias')
BEGIN
	CREATE TABLE tmpTransferencias (
		ID int IDENTITY (1, 1) PRIMARY KEY NOT NULL,
		FechaRegistro datetime NOT NULL,
		Descripcion nvarchar (50) NOT NULL,
		almacenOrigen nvarchar (8) NOT NULL,
		almacenDestino nvarchar (8) NOT NULL,
		operador nvarchar (12) NOT NULL,
		Notas nvarchar (255) NOT NULL 
	)

	CREATE TABLE tmpTransferenciasDetalles (
		Renglon int IDENTITY (1, 1) PRIMARY KEY NOT NULL,
		transID int NOT NULL,
		CodigoItem nvarchar (20) NOT NULL,
		Cantidad float NOT NULL DEFAULT 0
	)

	CREATE  UNIQUE  INDEX IX_tmpTransferenciasDetalles ON tmpTransferenciasDetalles(transID, Renglon)

	ALTER TABLE tmpTransferenciasDetalles ADD CONSTRAINT FK_tmpTransfDet_tmpTransf 
		FOREIGN KEY (transID) REFERENCES tmpTransferencias (ID)
		ON UPDATE CASCADE ON DELETE CASCADE
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'tmpTransferenciasDetalles' AND COLUMN_NAME = 'Renglon')
BEGIN
  ALTER TABLE tmpTransferenciasDetalles 
    ADD Renglon INT IDENTITY (1, 1) PRIMARY KEY NOT NULL
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'itemsVenta' AND COLUMN_NAME = 'porcentajeImputable')
BEGIN
	ALTER TABLE itemsVenta
		ADD porcentajeImputable FLOAT NOT NULL DEFAULT 0,
			Regulado TINYINT NOT NULL DEFAULT 0
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'condiciones' AND COLUMN_NAME = 'intervalo')
BEGIN
	ALTER TABLE Condiciones
	  ADD intervalo NVARCHAR(4) NOT NULL DEFAULT 'd'
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'facturasPOS' AND COLUMN_NAME = 'tipoConsumo')
BEGIN
	ALTER TABLE FacturasPOS
	  ADD tipoConsumo TINYINT NOT NULL DEFAULT 0
END

IF NOT EXISTS(SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_NAME = 'chequeDevueltoComis')
BEGIN
	CREATE TABLE chequeDevueltoComis(
		id int IDENTITY(1,1) PRIMARY KEY NOT NULL,
		idCheque int NOT NULL DEFAULT 0,
		tipoDocRel nvarchar(3) NOT NULL DEFAULT '',
		refDocRel nvarchar(20) NOT NULL DEFAULT '',
		codigoVendedor nvarchar(15) NOT NULL DEFAULT '',
		montoComision money NOT NULL DEFAULT 0
	)

	exec sp_executesql N'ALTER TABLE chequeDevueltoComis  
		ADD  CONSTRAINT FK_chequeDevueltoComis_ChequesDevueltos FOREIGN KEY(idCheque)
		REFERENCES ChequesDevueltos (id)
			ON UPDATE CASCADE
			ON DELETE CASCADE'

	exec sp_executesql N'ALTER TABLE chequeDevueltoComis  
		ADD  CONSTRAINT FK_chequeDevueltoComis_Vendedores FOREIGN KEY(codigoVendedor)
		REFERENCES Vendedores (codigo)
			ON UPDATE CASCADE
			ON DELETE CASCADE'
END
